From FEDORA_PATCHES Mon Sep 17 00:00:00 2001
From: Andrew Burgess <aburgess@redhat.com>
Date: Wed, 31 Jul 2024 15:58:20 +0100
Subject: gdb-backport-buildid-related-changes.patch

;; Backport patches related to build-id usage when opening a core
;; file, and also improving general build-id based lookup.  These will
;; all drop out when rebasing to GDB 16.

backport the following patches related to build-id usage

This one patch backports the following upstream commits:

  * 195795b0fd4 gdb: fix a target: prefix issue in find_separate_debug_file
  * ea4c968ce54 gdb: avoid '//' in filenames when searching for debuginfo
  * 22836ca8859 gdb: check for multiple matching build-id files
  * 6d45af96ea5 gdbserver: add gdbserver support for vFile::stat packet
  * 3055e3d2f13 gdb: add GDB side target_ops::fileio_stat implementation
  * 08a115cc1c4 gdb: add target_fileio_stat, but no implementations yet
  * c7e38ee47c9 gdb: avoid duplicate search in build_id_to_bfd_suffix
  * 10ac7e80c01 gdb: remove find_and_open_solib so_list method
  * 3e35b4deae2 gdb/testsuite: tests for debug lookup within the sysroot
  * 6dfd07222c0 gdb: convert separate-debug-file to new(ish) debug scheme
  * 5cabc8098e6 gdb/python: implement Python find_exec_by_build_id hook
  * ef1a41f20b7 gdb: add extension hook ext_lang_find_objfile_from_buildid
  * 629bcc68d79 gdb: rename ext_lang_missing_debuginfo_result
  * 73d7312ff61 gdb: use mapped file information to improve debuginfod text
  * 5ddd0d7eefb gdb/python: avoid depending on the curses library
  * 8358d39b4f0 gdb: unify build-id to objfile lookup code
  * fa826a4bbe9 gdb: improve shared library build-id check for core-files
  * a47a679c769 gdb/corefile: improve file backed mapping handling
  * 522875f679b gdb/corefile: don't pretend unavailable sections are readable
  * 97832471899 gdb/build-id: protect against weirdly short build-ids
  * 9543c37620c gdb/testsuite: make gdb_gnu_strip_debug consistent
  * fc240bb143c gdb/fileio: fix errno for packets where an attachment is expected
  * df0445b370f gdb/testsuite: fix typo 'unsupport' to 'unsupported'

I've merged these into a single (large) patch as these all merged
without any changes (i.e. these represent exactly the upstream code),
and all of these will be included in GDB 16, and so should all drop
out together when we rebase to GDB 16 (the next rebase).

All of these patches relate to either build-id usage when opening a
core file, or improving GDB's build-id based debug lookup.

diff --git a/gdb/NEWS b/gdb/NEWS
--- a/gdb/NEWS
+++ b/gdb/NEWS
@@ -1,6 +1,36 @@
 		What has changed in GDB?
 	     (Organized release by release)
 
+*** Change since GDB 15
+
+* Python API
+
+  ** New module gdb.missing_objfile that facilitates dealing with
+     missing objfiles when opening a core-file.
+
+  ** New function gdb.missing_objfile.register_handler that can
+     register an instance of a sub-class of
+     gdb.missing_debug.MissingObjfileHandler as a handler for missing
+     objfiles.
+
+  ** New class gdb.missing_objfile.MissingObjfileHandler which can be
+     sub-classed to create handlers for missing objfiles.
+
+* New commands
+
+info missing-objfile-handlers
+  List all the registered missing-objfile handlers.
+
+enable missing-objfile-handler LOCUS HANDLER
+disable missing-objfile-handler LOCUS HANDLER
+  Enable or disable a missing-objfile handler with a name matching the
+  regular expression HANDLER, in LOCUS.
+
+  LOCUS can be 'global' to operate on global missing-objfile handler,
+  'progspace' to operate on handlers within the current program space,
+  or can be a regular expression which is matched against the filename
+  of the primary executable in each program space.
+
 *** Changes in GDB 15
 
 * The MPX commands "show/set mpx bound" have been deprecated, as Intel
@@ -212,6 +242,11 @@ qIsAddressTagged
   file is about, this new packet provides a more generic way to perform such
   a check.
 
+vFile:stat
+  Return information about files on the remote system.  Like
+  vFile:fstat but takes a filename rather than an open file
+  descriptor.
+
 *** Changes in GDB 14
 
 * GDB now supports the AArch64 Scalable Matrix Extension 2 (SME2), which
diff --git a/gdb/build-id.c b/gdb/build-id.c
--- a/gdb/build-id.c
+++ b/gdb/build-id.c
@@ -26,6 +26,9 @@
 #include "filenames.h"
 #include "gdbcore.h"
 #include "cli/cli-style.h"
+#include "gdbsupport/scoped_fd.h"
+#include "debuginfod-support.h"
+#include "extension.h"
 
 /* See build-id.h.  */
 
@@ -73,73 +76,177 @@ build_id_verify (bfd *abfd, size_t check_len, const bfd_byte *check)
   return retval;
 }
 
-/* Helper for build_id_to_debug_bfd.  LINK is a path to a potential
-   build-id-based separate debug file, potentially a symlink to the real file.
-   If the file exists and matches BUILD_ID, return a BFD reference to it.  */
+/* Helper for build_id_to_debug_bfd.  ORIGINAL_LINK with SUFFIX appended is
+   a path to a potential build-id-based separate debug file, potentially a
+   symlink to the real file.  If the file exists and matches BUILD_ID,
+   return a BFD reference to it.  */
 
 static gdb_bfd_ref_ptr
-build_id_to_debug_bfd_1 (const std::string &link, size_t build_id_len,
-			 const bfd_byte *build_id)
+build_id_to_debug_bfd_1 (const std::string &original_link,
+			 size_t build_id_len, const bfd_byte *build_id,
+			 const char *suffix)
 {
-  if (separate_debug_file_debug)
+  tribool supports_target_stat = TRIBOOL_UNKNOWN;
+
+  /* Drop the 'target:' prefix if the target filesystem is local.  */
+  std::string_view original_link_view (original_link);
+  if (is_target_filename (original_link) && target_filesystem_is_local ())
+    original_link_view
+      = original_link_view.substr (strlen (TARGET_SYSROOT_PREFIX));
+
+  /* The upper bound of '10' here is completely arbitrary.  The loop should
+     terminate via 'break' when either (a) a readable symlink is found, or
+     (b) a non-existing entry is found.
+
+     However, for remote targets, we rely on the remote returning sane
+     error codes.  If a remote sends back the wrong error code then it
+     might trick GDB into thinking that the symlink exists, but points to a
+     missing file, in which case GDB will try the next seqno.  We don't
+     want a broken remote to cause GDB to spin here forever, hence a fixed
+     upper bound.  */
+
+  for (unsigned seqno = 0; seqno < 10; seqno++)
     {
-      gdb_printf (gdb_stdlog, _("  Trying %s..."), link.c_str ());
-      gdb_flush (gdb_stdlog);
-    }
+      std::string link (original_link_view);
 
-  /* lrealpath() is expensive even for the usually non-existent files.  */
-  gdb::unique_xmalloc_ptr<char> filename_holder;
-  const char *filename = nullptr;
-  if (is_target_filename (link))
-    filename = link.c_str ();
-  else if (access (link.c_str (), F_OK) == 0)
-    {
-      filename_holder.reset (lrealpath (link.c_str ()));
-      filename = filename_holder.get ();
-    }
+      if (seqno > 0)
+	string_appendf (link, ".%u", seqno);
 
-  if (filename == NULL)
-    {
-      if (separate_debug_file_debug)
-	gdb_printf (gdb_stdlog,
-		    _(" no, unable to compute real path\n"));
+      link += suffix;
 
-      return {};
-    }
+      separate_debug_file_debug_printf ("Trying %s...", link.c_str ());
 
-  /* We expect to be silent on the non-existing files.  */
-  gdb_bfd_ref_ptr debug_bfd = gdb_bfd_open (filename, gnutarget);
+      gdb::unique_xmalloc_ptr<char> filename_holder;
+      const char *filename = nullptr;
+      if (is_target_filename (link))
+	{
+	  gdb_assert (link.length () >= strlen (TARGET_SYSROOT_PREFIX));
+	  const char *link_on_target
+	    = link.c_str () + strlen (TARGET_SYSROOT_PREFIX);
+
+	  fileio_error target_errno;
+	  if (supports_target_stat != TRIBOOL_FALSE)
+	    {
+	      struct stat sb;
+	      int res = target_fileio_stat (nullptr, link_on_target, &sb,
+					    &target_errno);
+
+	      if (res != 0 && target_errno != FILEIO_ENOSYS)
+		{
+		  separate_debug_file_debug_printf ("path doesn't exist");
+		  break;
+		}
+	      else if (res != 0 && target_errno == FILEIO_ENOSYS)
+		supports_target_stat = TRIBOOL_FALSE;
+	      else
+		{
+		  supports_target_stat = TRIBOOL_TRUE;
+		  filename = link.c_str ();
+		}
+	    }
+
+	  if (supports_target_stat == TRIBOOL_FALSE)
+	    {
+	      gdb_assert (filename == nullptr);
+
+	      /* Connecting to a target that doesn't support 'stat'.  Try
+		 'readlink' as an alternative.  This isn't ideal, but is
+		 maybe better than nothing.  Returns EINVAL if the path
+		 isn't a symbolic link, which hints that the path is
+		 available -- there are other errors e.g. ENOENT for when
+		 the path doesn't exist, but we just assume that anything
+		 other than EINVAL indicates the path doesn't exist.  */
+	      std::optional<std::string> link_target
+		= target_fileio_readlink (nullptr, link_on_target,
+					  &target_errno);
+	      if (link_target.has_value ()
+		  || target_errno == FILEIO_EINVAL)
+		filename = link.c_str ();
+	      else
+		{
+		  separate_debug_file_debug_printf ("path doesn't exist");
+		  break;
+		}
+	    }
+	}
+      else
+	{
+	  struct stat buf;
+
+	  /* The `access' call below automatically dereferences LINK, but
+	     we want to stop incrementing SEQNO once we find a symlink
+	     that doesn't exist.  */
+	  if (lstat (link.c_str (), &buf) != 0)
+	    {
+	      separate_debug_file_debug_printf ("path doesn't exist");
+	      break;
+	    }
+
+	  /* Can LINK be accessed, or if LINK is a symlink, can the file
+	     pointed too be accessed?  Do this as lrealpath() is
+	     expensive, even for the usually non-existent files.  */
+	  if (access (link.c_str (), F_OK) == 0)
+	    {
+	      filename_holder.reset (lrealpath (link.c_str ()));
+	      filename = filename_holder.get ();
+	    }
+	}
 
-  if (debug_bfd == NULL)
-    {
-      if (separate_debug_file_debug)
-	gdb_printf (gdb_stdlog, _(" no, unable to open.\n"));
+      if (filename == nullptr)
+	{
+	  separate_debug_file_debug_printf ("unable to compute real path");
+	  continue;
+	}
 
-      return {};
-    }
+      /* We expect to be silent on the non-existing files.  */
+      gdb_bfd_ref_ptr debug_bfd = gdb_bfd_open (filename, gnutarget);
 
-  if (!build_id_verify (debug_bfd.get(), build_id_len, build_id))
-    {
-      if (separate_debug_file_debug)
-	gdb_printf (gdb_stdlog, _(" no, build-id does not match.\n"));
+      if (debug_bfd == NULL)
+	{
+	  separate_debug_file_debug_printf ("unable to open `%s`", filename);
+	  continue;
+	}
 
-      return {};
-    }
+      if (!build_id_verify (debug_bfd.get(), build_id_len, build_id))
+	{
+	  separate_debug_file_debug_printf ("build-id does not match");
+	  continue;
+	}
 
-  if (separate_debug_file_debug)
-    gdb_printf (gdb_stdlog, _(" yes!\n"));
+      separate_debug_file_debug_printf ("found a match");
+      return debug_bfd;
+    }
 
-  return debug_bfd;
+  separate_debug_file_debug_printf ("no suitable file found");
+  return {};
 }
 
 /* Common code for finding BFDs of a given build-id.  This function
    works with both debuginfo files (SUFFIX == ".debug") and executable
-   files (SUFFIX == "").  */
+   files (SUFFIX == "").
+
+   The build-id will be split into a single byte sub-directory, followed by
+   the remaining build-id bytes as the filename, i.e. we use the lookup
+   format: `.build-id/xx/yy....zz`.  As a consequence, if BUILD_ID_LEN is
+   less than 2 (bytes), no results will be found as there are not enough
+   bytes to form the `yy....zz` part of the lookup filename.  */
 
 static gdb_bfd_ref_ptr
 build_id_to_bfd_suffix (size_t build_id_len, const bfd_byte *build_id,
 			const char *suffix)
 {
+  SEPARATE_DEBUG_FILE_SCOPED_DEBUG_ENTER_EXIT;
+
+  if (build_id_len < 2)
+    {
+      /* Zero length build-ids are ignored by bfd.  */
+      gdb_assert (build_id_len > 0);
+      separate_debug_file_debug_printf
+	("Ignoring short build-id `%s' for build-id based lookup",
+	 bin2hex (build_id, build_id_len).c_str ());
+      return {};
+    }
+
   /* Keep backward compatibility so that DEBUG_FILE_DIRECTORY being "" will
      cause "/.build-id/..." lookups.  */
 
@@ -158,30 +265,33 @@ build_id_to_bfd_suffix (size_t build_id_len, const bfd_byte *build_id,
       std::string link = debugdir.get ();
       link += "/.build-id/";
 
-      if (size > 0)
-	{
-	  size--;
-	  string_appendf (link, "%02x/", (unsigned) *data++);
-	}
+      gdb_assert (size > 1);
+      size--;
+      string_appendf (link, "%02x/", (unsigned) *data++);
 
       while (size-- > 0)
 	string_appendf (link, "%02x", (unsigned) *data++);
 
-      link += suffix;
-
       gdb_bfd_ref_ptr debug_bfd
-	= build_id_to_debug_bfd_1 (link, build_id_len, build_id);
+	= build_id_to_debug_bfd_1 (link, build_id_len, build_id, suffix);
       if (debug_bfd != NULL)
 	return debug_bfd;
 
       /* Try to look under the sysroot as well.  If the sysroot is
 	 "/the/sysroot", it will give
-	 "/the/sysroot/usr/lib/debug/.build-id/ab/cdef.debug".  */
+	 "/the/sysroot/usr/lib/debug/.build-id/ab/cdef.debug".
+
+	 If the sysroot is 'target:' and the target filesystem is local to
+	 GDB then 'target:/path/to/check' becomes '/path/to/check' which
+	 we just checked above.  */
 
-      if (!gdb_sysroot.empty ())
+      if (!gdb_sysroot.empty ()
+	  && (gdb_sysroot != TARGET_SYSROOT_PREFIX
+	      || !target_filesystem_is_local ()))
 	{
 	  link = gdb_sysroot + link;
-	  debug_bfd = build_id_to_debug_bfd_1 (link, build_id_len, build_id);
+	  debug_bfd = build_id_to_debug_bfd_1 (link, build_id_len, build_id,
+					       suffix);
 	  if (debug_bfd != NULL)
 	    return debug_bfd;
 	}
@@ -198,9 +308,11 @@ build_id_to_debug_bfd (size_t build_id_len, const bfd_byte *build_id)
   return build_id_to_bfd_suffix (build_id_len, build_id, ".debug");
 }
 
-/* See build-id.h.  */
+/* Find and open a BFD for an executable file given a build-id.  If no BFD
+   can be found, return NULL.  The returned reference to the BFD must be
+   released by the caller.  */
 
-gdb_bfd_ref_ptr
+static gdb_bfd_ref_ptr
 build_id_to_exec_bfd (size_t build_id_len, const bfd_byte *build_id)
 {
   return build_id_to_bfd_suffix (build_id_len, build_id, "");
@@ -217,10 +329,9 @@ find_separate_debug_file_by_buildid (struct objfile *objfile,
   build_id = build_id_bfd_get (objfile->obfd.get ());
   if (build_id != NULL)
     {
-      if (separate_debug_file_debug)
-	gdb_printf (gdb_stdlog,
-		    _("\nLooking for separate debug info (build-id) for "
-		      "%s\n"), objfile_name (objfile));
+      SEPARATE_DEBUG_FILE_SCOPED_DEBUG_START_END
+	("looking for separate debug info (build-id) for %s",
+	 objfile_name (objfile));
 
       gdb_bfd_ref_ptr abfd (build_id_to_debug_bfd (build_id->size,
 						   build_id->data));
@@ -229,9 +340,9 @@ find_separate_debug_file_by_buildid (struct objfile *objfile,
 	  && filename_cmp (bfd_get_filename (abfd.get ()),
 			   objfile_name (objfile)) == 0)
 	{
-	  if (separate_debug_file_debug)
-	    gdb_printf (gdb_stdlog, "\"%s\": separate debug info file has no "
-			"debug info", bfd_get_filename (abfd.get ()));
+	  separate_debug_file_debug_printf
+	    ("\"%s\": separate debug info file has no debug info",
+	     bfd_get_filename (abfd.get ()));
 	  warnings->warn (_("\"%ps\": separate debug info file has no "
 			    "debug info"),
 			  styled_string (file_name_style.style (),
@@ -243,3 +354,78 @@ find_separate_debug_file_by_buildid (struct objfile *objfile,
 
   return std::string ();
 }
+
+/* See build-id.h.  */
+
+gdb_bfd_ref_ptr
+find_objfile_by_build_id (program_space *pspace,
+			  const bfd_build_id *build_id,
+			  const char *expected_filename)
+{
+  gdb_bfd_ref_ptr abfd;
+
+  for (unsigned attempt = 0, max_attempts = 1;
+       attempt < max_attempts && abfd == nullptr;
+       ++attempt)
+    {
+      /* Try to find the executable (or shared object) by looking for a
+	 (sym)link on disk from the build-id to the object file.  */
+      abfd = build_id_to_exec_bfd (build_id->size, build_id->data);
+
+      if (abfd != nullptr || attempt > 0)
+	break;
+
+      /* Attempt to query debuginfod for the executable.  This will only
+	 get run during the first attempt, if an extension language hook
+	 (see below) asked for a second attempt then we will have already
+	 broken out of the loop above.  */
+      gdb::unique_xmalloc_ptr<char> path;
+      scoped_fd fd = debuginfod_exec_query (build_id->data, build_id->size,
+					    expected_filename, &path);
+      if (fd.get () >= 0)
+	{
+	  abfd = gdb_bfd_open (path.get (), gnutarget);
+
+	  if (abfd == nullptr)
+	    warning (_("\"%ps\" from debuginfod cannot be opened as bfd: %s"),
+		     styled_string (file_name_style.style (), path.get ()),
+		     gdb_bfd_errmsg (bfd_get_error (), nullptr).c_str ());
+	  else if (!build_id_verify (abfd.get (), build_id->size,
+				     build_id->data))
+	    abfd = nullptr;
+	}
+
+      if (abfd != nullptr)
+	break;
+
+      ext_lang_missing_file_result ext_result
+	= ext_lang_find_objfile_from_buildid (pspace, build_id,
+					      expected_filename);
+      if (!ext_result.filename ().empty ())
+	{
+	  /* The extension identified the file for us.  */
+	  abfd = gdb_bfd_open (ext_result.filename ().c_str (), gnutarget);
+	  if (abfd == nullptr)
+	    {
+	      warning (_("\"%ps\" from extension cannot be opened as bfd: %s"),
+		       styled_string (file_name_style.style (),
+				      ext_result.filename ().c_str ()),
+		       gdb_bfd_errmsg (bfd_get_error (), nullptr).c_str ());
+	      break;
+	    }
+
+	  /* If the extension gave us a path to a file then we always
+	     assume that it is the correct file, we do no additional check
+	     of its build-id.  */
+	}
+      else if (ext_result.try_again ())
+	{
+	  /* The extension might have installed the file in the expected
+	     location, we should try again.  */
+	  max_attempts = 2;
+	  continue;
+	}
+    }
+
+  return abfd;
+}
diff --git a/gdb/build-id.h b/gdb/build-id.h
--- a/gdb/build-id.h
+++ b/gdb/build-id.h
@@ -40,13 +40,6 @@ extern int build_id_verify (bfd *abfd,
 extern gdb_bfd_ref_ptr build_id_to_debug_bfd (size_t build_id_len,
 					      const bfd_byte *build_id);
 
-/* Find and open a BFD for an executable file given a build-id.  If no BFD
-   can be found, return NULL.  The returned reference to the BFD must be
-   released by the caller.  */
-
-extern gdb_bfd_ref_ptr build_id_to_exec_bfd (size_t build_id_len,
-					     const bfd_byte *build_id);
-
 /* Find the separate debug file for OBJFILE, by using the build-id
    associated with OBJFILE's BFD.  If successful, returns the file name for the
    separate debug file, otherwise, return an empty string.
@@ -60,6 +53,22 @@ extern gdb_bfd_ref_ptr build_id_to_exec_bfd (size_t build_id_len,
 extern std::string find_separate_debug_file_by_buildid
   (struct objfile *objfile, deferred_warnings *warnings);
 
+/* Find an objfile (executable or shared library) that matches BUILD_ID.
+   This is done by first checking in the debug-file-directory for a
+   suitable .build-id/ sub-directory, and looking for a file with the
+   required build-id (usually a symbolic link or hard link to the actual
+   file).
+
+   If that doesn't find us a file then we call to debuginfod to see if it
+   can provide the required file.
+
+   EXPECTED_FILENAME is used in output messages from debuginfod, this
+   should be the file we were looking for but couldn't find.  */
+
+extern gdb_bfd_ref_ptr find_objfile_by_build_id
+  (struct program_space *pspace, const bfd_build_id *build_id,
+   const char *expected_filename);
+
 /* Return an hex-string representation of BUILD_ID.  */
 
 static inline std::string
